#ifndef _MYCOMMANDS_H_
#define _MYCOMMANDS_H_
#include <string.h>

// cmd macro, true only if str == macro
#define ISCMD(str, macro) !strncmp(str, macro, sizeof(macro))
#define IN_MAX 30000
#define OUT_MAX 100
#define DELIM " "
#define SPACE ' '

// top-level commands
#define LOAD "load" // for loading trajectories
#define SET "set"   // for setting global variable values
#define GET "get"   // for getting global values
#define EXEC "exec" // for executing reference trajectories
#define SAVE "save" // for saving data obtained during exec

//sublevel commands
#define HOLD "hold"	// tells PIC to just hold its current position
#define DIS "disable"	// disable motor control, and stop motor
#define ITUNE "itune"	// execute reference current trajectories
#define TRAJ "traj"	// for trajectories of encoder counts
#define HIFREQ "hifreq" // for saving high-frequency data
#define LOFREQ "lofreq" // for saving low-frequency data
#define VER "version"   // get code author and compilation date
#define DCMO "dcmo"	// manual PWM control
#define ENC "encoder"	// get/reset encoder counts
#define CURR "current"	// get current motor current
#define CGAINS "cgains" // get/set current control gains
#define MGAINS "mgains" // get/set motion control gains

char msg_in[IN_MAX];
char msg_out[OUT_MAX];

void ExecCommand(char *motor);
void SetCommand(char *cmd, char *data);
void GetCommand(char *cmd);
void LoadCommand(char *traj);
void SaveCommand(char *cmd);
int SplitInput(char *str, char **cmd, char **data);
void SendArrays(int rows, int cols, char *fmt, ...);
#endif /* _MYCOMMANDS_H_ */
